import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _ from 'lodash';
import moment from 'moment';
import React, { PureComponent, Fragment } from 'react';
import { DatePicker, Select, Radio, Icon, Form, Input, Button, Modal, Card, InputNumber, Tooltip, Table } from 'antd';
import FieldType from '../Constants/FieldType';
import OptionType from '../Constants/OptionType';
import InputStyle from '../Constants/InputStyle';
import MoneyInput from '../MoneyInput';

var FormItem = Form.Item;
var Option = Select.Option;

var RadioButton = Radio.Button;
var RadioGroup = Radio.Group;
var InputGroup = Input.Group;
var DefaultFieldType = FieldType.Custom;
var DefaultOptionType = OptionType.Custom;

var InnerFormCoreFieldsNew = function (_PureComponent) {
  _inherits(InnerFormCoreFieldsNew, _PureComponent);

  function InnerFormCoreFieldsNew() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreFieldsNew);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      form: {},
      parent: null,
      parents: [],
      inputSelectOptions: [],
      inputStyle: null,
      fieldType: DefaultFieldType,
      selectOptions: [],
      selectOptionEditing: false,
      selectOptionVisible: false,
      selectOptionRecord: null
    }, _this.fetch = function (props) {
      _this.setState({
        loading: true
      });
      props.fetch(function (data0) {
        _this.setState({
          form: data0
        });
        if (data0.Parents.length > 0) {
          data0.Parents.forEach(function (form0) {
            props.fetchSpecific(form0.Id, function (data) {
              var section = data0.Sections.find(function (x) {
                return '' + x.Id === props.sectionId;
              });
              var formParent = data;
              var parents = [];
              if (section.ParentId > 0) {
                parents = _.filter(formParent.Fields, function (y) {
                  return section.ParentId === y.SectionId;
                });
              }
              _this.setState(function (prevState) {
                var oldParents = prevState.parents || [];
                return {
                  loading: false,
                  parents: oldParents.concat(parents)
                };
              });
            });
          });
        } else {
          _this.setState({
            loading: false
          });
        }
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      var selectOptions = _this.state.selectOptions;

      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          var data = _extends({}, values);
          delete data.ModalOptionType;
          delete data.ModalValue;
          delete data.ModalDisplay;
          if (data.Column && Array.isArray(data.Column) && data.Column.length === 1) {
            var _data$Column = data.Column;
            data.Column = _data$Column[0];
          }
          if (InputStyle.RangePicker === data.InputStyle) {
            data.DefaultValue = [data.DefaultValue0, data.DefaultValue1];
            data.PlaceHolder = [data.PlaceHolder0, data.PlaceHolder1];
            delete data.DefaultValue0;
            delete data.DefaultValue1;
            delete data.PlaceHolder0;
            delete data.PlaceHolder1;
          }
          if (InputStyle.InputNumber === data.InputStyle) {
            data.Payload = {
              Prefix: data.Prefix,
              Suffix: data.Suffix
            };
            delete data.Prefix;
            delete data.Suffix;
          }
          if (InputStyle.Select === data.InputStyle) {
            data.Payload = {
              Mode: data.Mode,
              TokenSeparators: [','],
              Options: selectOptions
            };
          }
          if (_this.props.handleSubmit) {
            _this.props.handleSubmit(data, selectOptions);
          }
          _this.props.submit(data);
        }
      });
    }, _this.handleOptionOk = function () {
      _this.setState(function (prevState) {
        var selectOptionEditing = prevState.selectOptionEditing,
            selectOptionRecord = prevState.selectOptionRecord,
            selectOptions = prevState.selectOptions;

        var newSelectOptions = _.clone(selectOptions);
        var recordValue = null;
        if (selectOptionEditing) {
          var record = newSelectOptions.find(function (x) {
            return x.ID === selectOptionRecord.ID;
          });
          record.Display = _this.props.form.getFieldValue('ModalDisplay');
          record.OptionType = _this.props.form.getFieldValue('ModalOptionType');
          if (OptionType.Custom === record.OptionType) {
            record.Value = record.Display;
            recordValue = record.Display;
          } else {
            record.Value = _this.props.form.getFieldValue('ModalValue');
            recordValue = _this.props.form.getFieldValue('ModalValue');
          }
        } else {
          var maxID = _.max(_.map(selectOptions, function (o) {
            return o.ID;
          })) || 0;
          var h = {
            ID: maxID + 1,
            Value: _this.props.form.getFieldValue(OptionType.Custom === _this.props.form.getFieldValue('ModalOptionType') ? 'ModalDisplay' : 'ModalValue'),
            Display: _this.props.form.getFieldValue('ModalDisplay'),
            FieldType: _this.props.form.getFieldValue('ModalOptionType')
          };
          recordValue = h.Value;
          newSelectOptions.push(h);
        }
        _this.props.form.setFieldsValue({
          ModalOptionType: DefaultOptionType,
          ModalValue: null,
          ModalDisplay: null
        });

        if (_this.props.handleOptionOk) {
          _this.props.handleOptionOk({}, recordValue, _this.props.form.getFieldValue);
        }

        return {
          selectOptions: newSelectOptions,
          selectOptionRecord: {},
          selectOptionEditing: false,
          selectOptionVisible: false
        };
      });
    }, _this.handleOptionCancel = function () {
      _this.setState({
        selectOptionRecord: {},
        selectOptionEditing: false,
        selectOptionVisible: false
      });
      _this.props.form.setFieldsValue({
        ModalOptionType: DefaultOptionType,
        ModalValue: null,
        ModalDisplay: null
      });
    }, _this.handleDeleteOption = function (option) {
      var ID = option.ID;

      _this.setState(function (prevState) {
        var selectOptions = prevState.selectOptions;

        var newSelectOptions = _.clone(selectOptions);
        _.remove(newSelectOptions, function (o) {
          return o.ID === ID;
        });
        return {
          selectOptions: newSelectOptions
        };
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreFieldsNew.prototype.componentDidMount = function componentDidMount() {
    this.fetch(this.props);
  };

  InnerFormCoreFieldsNew.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch(nextProps);
    }
  };

  InnerFormCoreFieldsNew.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        form = _state.form,
        parent = _state.parent,
        parents = _state.parents,
        inputSelectOptions = _state.inputSelectOptions;
    var _state2 = this.state,
        inputStyle = _state2.inputStyle,
        fieldType = _state2.fieldType;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var formItemLayoutModal = {
      labelCol: {
        xs: { span: 6 }
      },
      wrapperCol: {
        xs: { span: 18 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    var inputDefaultValue = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Default Value',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(React.createElement(Input, { placeholder: 'Default value of the field' }))
    );

    var inputPlaceholder = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Placeholder',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('PlaceHolder', {
        initialValue: parent ? parent.PlaceHolder : null
      })(React.createElement(Input, { placeholder: 'Text displayed when the field is blank' }))
    );

    var rangeDefaultValue = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Default Value',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        ),
        style: { margin: 0 }
      }),
      React.createElement(
        InputGroup,
        { compact: true },
        React.createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('DefaultValue0', {
            initialValue: parent ? parent.DefaultValue && Array.isArray(parent.DefaultValue) && parent.DefaultValue[0] ? moment(parent.DefaultValue[0]) : null : null
          })(React.createElement(DatePicker, { className: 'formcore_range', placeholder: 'Left' }))
        ),
        React.createElement(Input, {
          style: {
            width: 30,
            pointerEvents: 'none',
            backgroundColor: '#fff',
            position: 'relative',
            top: 4,
            border: 0
          },
          placeholder: '~',
          disabled: true
        }),
        React.createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('DefaultValue1', {
            initialValue: parent ? parent.DefaultValue && Array.isArray(parent.DefaultValue) && parent.DefaultValue[1] ? moment(parent.DefaultValue[1]) : null : null
          })(React.createElement(DatePicker, { className: 'formcore_range', placeholder: 'Right' }))
        )
      )
    );

    var rangePlaceholder = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Placeholder',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        ),
        style: { margin: 0 }
      }),
      React.createElement(
        InputGroup,
        { compact: true },
        React.createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('PlaceHolder0', {
            initialValue: parent ? parent.PlaceHolder && Array.isArray(parent.PlaceHolder) && parent.PlaceHolder[0] ? parent.PlaceHolder[0] : null : null
          })(React.createElement(Input, { className: 'formcore_range', placeholder: 'Left' }))
        ),
        React.createElement(Input, {
          style: {
            width: 30,
            pointerEvents: 'none',
            backgroundColor: '#fff',
            position: 'relative',
            top: 4,
            border: 0
          },
          placeholder: '~',
          disabled: true
        }),
        React.createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('PlaceHolder1', {
            initialValue: parent ? parent.PlaceHolder && Array.isArray(parent.PlaceHolder) && parent.PlaceHolder[1] ? parent.PlaceHolder[1] : null : null
          })(React.createElement(Input, { className: 'formcore_range', placeholder: 'Right' }))
        )
      )
    );

    var moneyDefaultValue = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Default Value',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(React.createElement(MoneyInput, null))
    );

    var selectDefaultValue = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Default Value',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(React.createElement(
        Select,
        {
          mode: parent ? parent.Mode : null,
          tokenSeparators: parent ? parent.TokenSeparators : null
        },
        _.map(this.state.selectOptions || (parent ? parent.Options : []), function (option) {
          return React.createElement(
            Option,
            { key: option.Value, value: option.Value },
            option.Display
          );
        })
      ))
    );

    var numberDefaultValue = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Default Value',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(React.createElement(InputNumber, null))
    );

    var inputNumberPrefix = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Prefix',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('Prefix', {
        initialValue: parent ? parent.Prefix : null
      })(React.createElement(Input, { placeholder: 'Text displayed before the number' }))
    );

    var inputSelectMode = React.createElement(
      FormItem,
      _extends({}, formItemLayout, { label: 'Mode' }),
      getFieldDecorator('Mode', {
        initialValue: parent ? parent.Mode : null
      })(React.createElement(
        Select,
        {
          placeholder: 'Pick a select input box style',
          onChange: function onChange(x) {
            if (parent) {
              parent.Mode = x;
            }
          }
        },
        React.createElement(
          Option,
          { value: '' },
          'Dropdown'
        ),
        React.createElement(
          Option,
          { value: 'tags' },
          'Tags'
        ),
        React.createElement(
          Option,
          { value: 'multiple' },
          'Multiple'
        ),
        React.createElement(
          Option,
          { value: 'combobox' },
          'Combo-box'
        )
      ))
    );
    var inputSelectValues = React.createElement(
      Fragment,
      null,
      React.createElement(
        FormItem,
        _extends({}, formItemLayout, { label: 'Options' }),
        React.createElement(Table, {
          scrollWidth: 350,
          style: { maxHeight: 300, overflowY: 'auto' },
          size: 'small',
          rowKey: 'ID',
          columns: [{
            title: 'Option',
            dataIndex: 'Display',
            key: 'Display',
            width: 'calc(100% - 80px)',
            render: function render(text) {
              return text;
            }
          }, {
            title: React.createElement(Button, {
              type: 'primary',
              icon: 'plus',
              style: { float: 'right' },
              onClick: function onClick() {
                _this2.setState({
                  selectOptionRecord: {
                    OptionType: DefaultOptionType
                  },
                  selectOptionEditing: false,
                  selectOptionVisible: true
                });
              }
            }),
            dataIndex: '',
            key: 'ID',
            width: 80,
            render: function render(text, record) {
              return React.createElement(Button, {
                icon: 'edit',
                onClick: function onClick() {
                  _this2.props.form.setFieldsValue({
                    ModalOptionType: record.OptionType,
                    ModalValue: record.Value,
                    ModalDisplay: record.Display
                  });
                  _this2.setState({
                    selectOptionRecord: record,
                    selectOptionEditing: true,
                    selectOptionVisible: true
                  });
                }
              });
            }
          }],
          dataSource: this.state.selectOptions,
          pagination: false
        })
      ),
      React.createElement(
        Modal,
        {
          title: this.state.selectOptionEditing ? 'Edit: ' + this.state.selectOptionRecord.Display : 'New Option',
          visible: this.state.selectOptionVisible,
          onOk: this.handleOptionOk,
          onCancel: this.handleOptionCancel
        },
        React.createElement(
          FormItem,
          _extends({}, formItemLayoutModal, { label: 'Option Type' }),
          getFieldDecorator('ModalOptionType', {
            initialValue: this.state.selectOptionEditing ? this.state.selectOptionRecord.OptionType : DefaultOptionType
          })(React.createElement(
            RadioGroup,
            {
              onChange: function onChange(e) {
                if (_this2.state.selectOptionRecord) {
                  _this2.setState(function (st) {
                    return {
                      selectOptionRecord: _extends({}, st.selectOptionRecord, {
                        OptionType: e.target.value
                      })
                    };
                  });
                } else {
                  _this2.setState({
                    selectOptionRecord: {
                      OptionType: e.target.value
                    }
                  });
                }
                return true;
              }
            },
            React.createElement(
              Fragment,
              null,
              React.createElement(
                RadioButton,
                { value: OptionType.BuiltIn },
                'Built-in'
              ),
              React.createElement(
                RadioButton,
                { value: OptionType.Custom },
                'Custom'
              )
            )
          ))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayoutModal, {
            label: 'Built-in Option',
            style: {
              display: this.state.selectOptionRecord && OptionType.BuiltIn === this.state.selectOptionRecord.OptionType ? 'block' : 'none'
            }
          }),
          getFieldDecorator('ModalValue', {
            initialValue: this.state.selectOptionRecord ? this.state.selectOptionRecord.Value : null
          })(React.createElement(
            Select,
            {
              style: { width: '100%' },
              placeholder: 'Select a built-in option',
              onChange: function onChange(x) {
                _this2.props.form.setFieldsValue({
                  ModalDisplay: inputSelectOptions[x]
                });
                if (_this2.state.selectOptionRecord) {
                  _this2.setState(function (st) {
                    return {
                      selectOptionRecord: _extends({}, st.selectOptionRecord, {
                        Value: x,
                        Display: inputSelectOptions[x]
                      })
                    };
                  });
                } else {
                  _this2.setState({
                    selectOptionRecord: {
                      Value: x,
                      Display: inputSelectOptions[x]
                    }
                  });
                }
              }
            },
            _.map(_.keys(inputSelectOptions), function (key) {
              return React.createElement(
                Option,
                { key: key, value: key },
                inputSelectOptions[key]
              );
            })
          ))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayoutModal, { label: 'Displayed As' }),
          getFieldDecorator('ModalDisplay', {
            initialValue: this.state.selectOptionRecord ? this.state.selectOptionRecord.Display : null
          })(React.createElement(Input, { placeholder: 'How should this option be displayed' }))
        )
      )
    );

    var inputNumberSuffix = React.createElement(
      FormItem,
      _extends({}, formItemLayout, {
        label: React.createElement(
          'span',
          null,
          'Suffix',
          React.createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('Suffix', {
        initialValue: parent ? parent.Suffix : null
      })(React.createElement(Input, { placeholder: 'Text displayed after the number' }))
    );

    return React.createElement(
      Card,
      { bordered: false, loading: loading, title: 'New Field' },
      React.createElement(
        Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        form && form.Parents && form.Parents.length > 0 && parents && parents.length > 0 ? React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            help: React.createElement(
              'span',
              null,
              this.props.providedBy(form)
            ),
            label: React.createElement(
              'span',
              null,
              'Copy and Modify',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              ),
              '\xA0',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                React.createElement(
                  Tooltip,
                  { title: 'Select a field if you intend to copy and modify an existing field; otherwise leave it blank.' },
                  React.createElement(Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId')(React.createElement(
            Select,
            {
              allowClear: true,
              showSearch: true,
              placeholder: 'Select an existing field or leave it blank',
              onChange: function onChange(parentId) {
                var parentNew = null;
                _this2.setState(function (prevState) {
                  var inputStyleNew = prevState.inputStyleNew,
                      fieldTypeNew = prevState.fieldTypeNew;

                  if (parentId && parentId > 0) {
                    parentNew = parents.find(function (x) {
                      return x.Id === parentId;
                    });
                    if (parentNew) {
                      inputStyleNew = parentNew.InputStyle;
                      fieldTypeNew = parentNew.FieldType;
                    }
                  }
                  if (parentNew && parentNew.Payload) {
                    parentNew = _extends({}, parentNew, parentNew.Payload);
                  }
                  var h = {
                    parent: parentNew,
                    inputStyle: inputStyleNew,
                    fieldType: fieldTypeNew
                  };
                  if (parentNew && parentNew.Options && _.isArray(parentNew.Options)) {
                    h.inputSelectOptions = _this2.props.availableOptions(parentNew.Column);
                    h.selectOptions = _.map(parentNew.Options, function (option, i) {
                      return _extends({ ID: i }, option);
                    });
                  } else {
                    h.selectOptions = [];
                  }
                  return h;
                });
              }
            },
            parents.map(function (y) {
              return React.createElement(
                Select.Option,
                { key: y.Id, value: y.Id },
                y.Label
              );
            })
          ))
        ) : null,
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, { label: React.createElement(
              'span',
              null,
              'Type'
            ) }),
          getFieldDecorator('FieldType', {
            initialValue: fieldType
          })(React.createElement(
            RadioGroup,
            {
              onChange: function onChange(e) {
                _this2.setState({
                  fieldType: e.target.value
                });
                return true;
              }
            },
            React.createElement(
              RadioButton,
              { value: FieldType.BuiltIn },
              'Built-in'
            ),
            React.createElement(
              RadioButton,
              { value: FieldType.Custom },
              'Custom'
            )
          ))
        ),
        FieldType.BuiltIn !== fieldType ? null : React.createElement(
          FormItem,
          _extends({}, formItemLayout, { label: 'Built-in Columns' }),
          getFieldDecorator('Column', {
            rules: [{
              required: true,
              message: 'Built-in fields require at least one column'
            }],
            initialValue: parent && parent.Column ? ('' + parent.Column).split('__FORMCORE__') : []
          })(React.createElement(
            Select,
            {
              mode: 'tags',
              style: { width: '100%' },
              placeholder: 'Select built-in columns for this field',
              onChange: function onChange(handlers) {
                var availableOptions = _this2.props.availableOptions(handlers);
                var calcSelectOptions = [];
                var i = 0;
                _.each(availableOptions, function (val, key) {
                  i += 1;
                  calcSelectOptions.push({
                    ID: i,
                    Value: key,
                    Display: val,
                    OptionType: OptionType.BuiltIn
                  });
                });
                var h = {
                  inputSelectOptions: availableOptions,
                  selectOptions: calcSelectOptions
                };
                handlers.forEach(function (handler) {
                  var info = _this2.props.availableHandlers.find(function (x) {
                    return x[0] === handler;
                  });
                  if (info) {
                    h = _extends({}, h, info[3]);
                  }
                });
                _this2.setState(h);
              }
            },
            this.props.availableHandlers.map(function (x) {
              return React.createElement(
                Option,
                { value: x[0], key: x[0] },
                React.createElement(
                  Tooltip,
                  { placement: 'bottom', title: x[2] },
                  x[1]
                )
              );
            })
          ))
        ),
        FieldType.BuiltIn !== fieldType ? null : React.createElement(
          FormItem,
          _extends({}, formItemLayout, { label: 'Built-in Handlers' }),
          getFieldDecorator('Handlers', {
            initialValue: (parent || {}).Handlers || []
          })(React.createElement(
            Select,
            {
              mode: 'tags',
              style: { width: '100%' },
              placeholder: 'Select built-in handlers for this field'
            },
            this.props.availableHandlers.map(function (x) {
              return React.createElement(
                Option,
                { value: x[0], key: x[0] },
                React.createElement(
                  Tooltip,
                  { placement: 'bottom', title: x[2] },
                  x[1]
                )
              );
            })
          ))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: React.createElement(
              'span',
              null,
              'Label',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Label', {
            initialValue: parent ? parent.Label : null
          })(React.createElement(Input, { placeholder: 'Label of the field' }))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: 'Position',
            help: 'The higher the number is, the lower on the page will the field be displayed.'
          }),
          getFieldDecorator('Position', {
            rules: [{
              required: true,
              message: 'Please enter the position of the field'
            }],
            initialValue: parent ? parent.Position : 0
          })(React.createElement(InputNumber, { style: { width: '100%' } }))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, { label: 'Input Style' }),
          getFieldDecorator('InputStyle', {
            initialValue: inputStyle
          })(React.createElement(
            Select,
            {
              placeholder: 'Select the style of the field\'s input box',
              onChange: function onChange(x) {
                _this2.setState(function (pervState) {
                  var h = {
                    inputStyle: x
                  };
                  if (_this2.props.onInputStyleChange) {
                    _this2.props.onInputStyleChange(x, pervState, h);
                  }
                  return h;
                });
              }
            },
            _.map(_.keys(this.props.availableInputStyle), function (key) {
              return React.createElement(
                Option,
                {
                  key: _this2.props.availableInputStyle[key],
                  value: _this2.props.availableInputStyle[key]
                },
                key
              );
            })
          ))
        ),
        InputStyle.Hidden !== inputStyle ? null : inputDefaultValue,
        InputStyle.Input !== inputStyle ? null : inputDefaultValue,
        InputStyle.Input !== inputStyle ? null : inputPlaceholder,
        InputStyle.RangePicker !== inputStyle ? null : rangeDefaultValue,
        InputStyle.RangePicker !== inputStyle ? null : rangePlaceholder,
        InputStyle.MoneyInput !== inputStyle ? null : moneyDefaultValue,
        InputStyle.MoneyInput !== inputStyle ? null : inputPlaceholder,
        InputStyle.InputNumber !== inputStyle ? null : numberDefaultValue,
        InputStyle.InputNumber !== inputStyle ? null : inputPlaceholder,
        InputStyle.InputNumber !== inputStyle ? null : inputNumberPrefix,
        InputStyle.InputNumber !== inputStyle ? null : inputNumberSuffix,
        InputStyle.Select !== inputStyle ? null : inputSelectMode,
        InputStyle.Select !== inputStyle ? null : inputSelectValues,
        InputStyle.Select !== inputStyle ? null : selectDefaultValue,
        this.props.fieldRender && this.props.fieldRender({}, inputStyle, this.props.form.setFieldsValue, getFieldDecorator, formItemLayoutModal, formItemLayout, this.handleOptionOk, this.handleOptionCancel, this.state, this.setState),
        React.createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          React.createElement(
            Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFieldsNew;
}(PureComponent);

var FormCoreFieldsNew = Form.create()(InnerFormCoreFieldsNew);
export default FormCoreFieldsNew;