import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _ from 'lodash';
import React from 'react';
import { Card, Col, Row } from 'antd';
import RenderField from './RenderField';
import InputStyle from './Constants/InputStyle';

var FormCoreForm = function (_React$Component) {
  _inherits(FormCoreForm, _React$Component);

  function FormCoreForm() {
    _classCallCheck(this, FormCoreForm);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  FormCoreForm.prototype.render = function render() {
    var _props = this.props,
        form = _props.form,
        data = _props.data,
        sections = _props.sections,
        fields = _props.fields,
        renderExtra = _props.renderExtra,
        style = _props.style;

    var defaultValues = {};
    _.each(fields, function (x) {
      defaultValues[x.Column] = x.DefaultValue;
    });
    return sections.map(function (x) {
      var localFields = _.filter(fields, function (y) {
        return x.Id === y.SectionId;
      });
      if (x.ParentId > 0) {
        _.forEach(_.filter(fields, function (y) {
          return x.ParentId === y.SectionId;
        }), function (y) {
          if (undefined === _.find(localFields, function (z) {
            return z.ParentId === y.Id;
          })) {
            localFields.push(y);
          }
        });
      }
      var visibleFields = _.filter(localFields, function (f) {
        return f.InputStyle !== InputStyle.Hidden;
      });
      localFields.sort(function (a, b) {
        return a.Position - b.Position;
      });
      var rowColContent = null;
      if (localFields.length === 1) {
        rowColContent = RenderField(localFields[0], form, data, {}, renderExtra);
      } else {
        rowColContent = React.createElement(
          Row,
          { gutter: 16 },
          localFields.map(function (y) {
            return React.createElement(
              Col,
              { lg: 8, md: 12, sm: 24, key: y.Id, hidden: InputStyle.Hidden === y.InputStyle },
              RenderField(y, form, data, {}, renderExtra)
            );
          })
        );
      }
      return React.createElement(
        Card,
        {
          key: x.Id,
          title: x.Title,
          className: 'formcore_btm24',
          bordered: false,
          style: style,
          hidden: !(visibleFields && visibleFields.length > 0)
        },
        rowColContent
      );
    });
  };

  return FormCoreForm;
}(React.Component);

export default FormCoreForm;