import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _ from 'lodash';
import React from 'react';
import DescriptionList from 'ant-design-pro/lib/DescriptionList';
import ShowField from './ShowField';
import InputStyle from './Constants/InputStyle';

var FormCoreShow = function (_React$Component) {
  _inherits(FormCoreShow, _React$Component);

  function FormCoreShow() {
    _classCallCheck(this, FormCoreShow);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  FormCoreShow.prototype.render = function render() {
    var _props = this.props,
        data = _props.data,
        sections = _props.sections,
        fields = _props.fields,
        showExtra = _props.showExtra,
        style = _props.style;

    var defaultValues = {};
    _.each(fields, function (x) {
      defaultValues[x.Column] = x.DefaultValue;
    });
    return sections.map(function (x) {
      var localFields = _.filter(fields, function (y) {
        return x.Id === y.SectionId;
      });
      if (x.ParentId > 0) {
        _.forEach(_.filter(fields, function (y) {
          return x.ParentId === y.SectionId;
        }), function (y) {
          if (undefined === _.find(localFields, function (z) {
            return z.ParentId === y.Id;
          })) {
            localFields.push(y);
          }
        });
      }
      var visibleFields = _.filter(localFields, function (f) {
        return f.InputStyle !== InputStyle.Hidden;
      });
      localFields.sort(function (a, b) {
        return a.Position - b.Position;
      });
      var content = _.filter(localFields.map(function (y) {
        return ShowField(y, data, {}, showExtra);
      }), function (y) {
        return !!y;
      });
      return content.length > 0 ? React.createElement(
        DescriptionList,
        {
          key: x.Id,
          className: 'formcore_btm24',
          title: x.Title,
          style: style,
          hidden: !(visibleFields && visibleFields.length > 0)
        },
        content
      ) : null;
    });
  };

  return FormCoreShow;
}(React.Component);

export default FormCoreShow;