import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { PureComponent } from 'react';
import { Form, Button, Input, Card } from 'antd';

var FormItem = Form.Item;

var InnerFormCoreFormsEdit = function (_PureComponent) {
  _inherits(InnerFormCoreFormsEdit, _PureComponent);

  function InnerFormCoreFormsEdit() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreFormsEdit);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      entity: {}
    }, _this.fetch = function () {
      _this.setState({ loading: true });

      _this.props.fetch(function (entity) {
        var newEntity = _extends({ ParentId: entity.ParentIds[0] }, entity);
        _this.setState({ loading: false, entity: newEntity });
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.clearAjaxError(values);
          var newValues = _extends({ ParentIds: [values.ParentId] }, values);
          _this.props.submit(newValues);
        }
      });
    }, _this.clearAjaxError = function (origValues) {
      var fields = {
        Title: { value: origValues.Name, errors: null }
      };
      fields.ParentId = { value: origValues.Name, errors: null };
      _this.props.form.setFields(fields);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreFormsEdit.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  InnerFormCoreFormsEdit.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  InnerFormCoreFormsEdit.prototype.render = function render() {
    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        entity = _state.entity;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    return React.createElement(
      Card,
      { bordered: false, loading: loading, title: entity.Title ? entity.Title : null },
      React.createElement(
        Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: React.createElement(
              'span',
              null,
              'Title',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            rules: [{ required: true, message: 'Please enter the title of the new product offer' }],
            initialValue: entity.Title
          })(React.createElement(Input, { placeholder: 'Title of the new product offer' }))
        ),
        React.createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          React.createElement(
            Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFormsEdit;
}(PureComponent);

var FormCoreFormsEdit = Form.create()(InnerFormCoreFormsEdit);
export default FormCoreFormsEdit;