import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Component } from 'react';
import { Card } from 'antd';
import DescriptionList from 'ant-design-pro/lib/DescriptionList';

var Description = DescriptionList.Description;

var FormCoreFormsList = function (_Component) {
  _inherits(FormCoreFormsList, _Component);

  function FormCoreFormsList() {
    var _temp, _this, _ret;

    _classCallCheck(this, FormCoreFormsList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: true,
      forms: []
    }, _this.fetch = function () {
      _this.setState({
        loading: true
      });
      _this.props.fetch(function (data) {
        _this.setState({
          loading: false,
          forms: data
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  FormCoreFormsList.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  FormCoreFormsList.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  FormCoreFormsList.prototype.render = function render() {
    var _this2 = this;

    var _state = this.state,
        loading = _state.loading,
        forms = _state.forms;

    return React.createElement(
      Card,
      {
        className: 'formcore-card-button-fix',
        style: { marginBottom: 24 },
        title: 'Product Offers',
        bordered: false,
        extra: this.props.newFormButton,
        loading: loading
      },
      React.createElement(
        DescriptionList,
        { size: 'large' },
        forms && forms.length > 0 ? forms.map(function (x) {
          return React.createElement(
            Description,
            { key: x.Id },
            _this2.props.formLink(x)
          );
        }) : React.createElement(
          'div',
          { className: 'ant-list-empty-text', style: { paddingBottom: 32 } },
          'No data'
        )
      )
    );
  };

  return FormCoreFormsList;
}(Component);

export default FormCoreFormsList;