import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import numeral from 'numeral';
import React from 'react';
import { Input, Tooltip } from 'antd';

var MoneyInput = function (_React$Component) {
  _inherits(MoneyInput, _React$Component);

  function MoneyInput() {
    var _temp, _this, _ret;

    _classCallCheck(this, MoneyInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onChange = function (e) {
      var value = e.target.value;

      var reg = /^-?(0|[1-9][0-9]*)(\.[0-9]*)?$/;
      if (!Number.isNaN(value) && reg.test(value) || value === '' || value === '-') {
        _this.props.onChange(value);
      }
    }, _this.onBlur = function () {
      var _this$props = _this.props,
          value = _this$props.value,
          onBlur = _this$props.onBlur,
          onChange = _this$props.onChange;

      if (value && (value.charAt(value.length - 1) === '.' || value === '-')) {
        onChange({ value: value.slice(0, -1) });
      }
      if (onBlur) {
        onBlur();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // '.' at the end or only '-' in the input box.


  MoneyInput.prototype.render = function render() {
    var _props = this.props,
        value = _props.value,
        _props$addonBefore = _props.addonBefore,
        addonBefore = _props$addonBefore === undefined ? '$' : _props$addonBefore,
        addonAfter = _props.addonAfter,
        _props$placeholder = _props.placeholder,
        placeholder = _props$placeholder === undefined ? '0.00' : _props$placeholder,
        _props$formatTooltip = _props.formatTooltip,
        formatTooltip = _props$formatTooltip === undefined ? true : _props$formatTooltip,
        restProps = _objectWithoutProperties(_props, ['value', 'addonBefore', 'addonAfter', 'placeholder', 'formatTooltip']);

    var title = 'Input an amount';
    if (value) {
      title = value;
      if (formatTooltip) title = React.createElement(
        'span',
        { className: 'formcore-numeric-input-title' },
        value !== '-' ? '$' + numeral(value).format('0,0.00') : '-'
      );
    }

    return React.createElement(
      'div',
      { className: 'formcore_moneyinput' },
      React.createElement(
        Tooltip,
        {
          trigger: ['focus'],
          title: title,
          placement: 'bottomLeft',
          overlayClassName: 'formcore-numeric-input'
        },
        React.createElement(Input, _extends({}, restProps, {
          value: value,
          onChange: this.onChange,
          onBlur: this.onBlur,
          addonBefore: addonBefore,
          addonAfter: addonAfter,
          placeholder: placeholder,
          maxLength: '25',
          autoComplete: 'off'
        }))
      )
    );
  };

  return MoneyInput;
}(React.Component);

export default MoneyInput;