import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { PureComponent } from 'react';
import { Select, Icon, Form, Input, Button, Card, InputNumber, Tooltip } from 'antd';

var FormItem = Form.Item;

var InnerFormCoreSectionsEdit = function (_PureComponent) {
  _inherits(InnerFormCoreSectionsEdit, _PureComponent);

  function InnerFormCoreSectionsEdit() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreSectionsEdit);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      form: {},
      parents: []
    }, _this.fetch = function (props) {
      _this.setState({
        loading: true
      });
      props.fetch(function (data0) {
        _this.setState({
          form: data0
        });
        if (data0.Parents.length > 0) {
          data0.Parents.forEach(function (form0) {
            props.fetchSpecific(form0.Id, function (data1) {
              _this.setState(function (prevState) {
                var oldParents = prevState.parents || [];
                return {
                  parents: oldParents.concat(data1.Sections),
                  loading: false
                };
              });
            });
          });
        } else {
          _this.setState({
            loading: false
          });
        }
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.props.submit(values);
        }
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreSectionsEdit.prototype.componentDidMount = function componentDidMount() {
    this.fetch(this.props);
  };

  InnerFormCoreSectionsEdit.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch(nextProps);
    }
  };

  InnerFormCoreSectionsEdit.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        form = _state.form,
        parents = _state.parents;

    var entity = form && form.Sections ? form.Sections.find(function (x) {
      return '' + x.Id === _this2.props.sectionId;
    }) : {};

    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    return React.createElement(
      Card,
      {
        className: 'formcore-card-button-fix',
        bordered: false,
        loading: loading,
        title: entity.Title ? 'Section: ' + entity.Title : 'Section'
      },
      React.createElement(
        Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        form && form.Parents && form.Parents.length > 0 ? React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            help: React.createElement(
              'span',
              null,
              this.props.providedBy(form)
            ),
            label: React.createElement(
              'span',
              null,
              'Copy and Modify',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              ),
              '\xA0',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                React.createElement(
                  Tooltip,
                  { title: 'Select a section if you intend to copy and modify an existing section; otherwise leave it blank.' },
                  React.createElement(Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId', {
            initialValue: entity.ParentId > 0 ? entity.ParentId : null
          })(React.createElement(
            Select,
            {
              allowClear: true,
              showSearch: true,
              placeholder: 'Select an existing section or leave it blank'
            },
            parents.map(function (x) {
              return React.createElement(
                Select.Option,
                { key: x.Id, value: x.Id },
                x.Title
              );
            })
          ))
        ) : null,
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: React.createElement(
              'span',
              null,
              'Title',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            initialValue: entity.Title
          })(React.createElement(Input, { placeholder: 'Title of the section' }))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: 'Position',
            help: 'The higher the number is, the lower on the page will the section be displayed.'
          }),
          getFieldDecorator('Position', {
            rules: [{
              required: true,
              message: 'Please enter the position of the section'
            }],
            initialValue: entity.Position
          })(React.createElement(InputNumber, { style: { width: '100%' } }))
        ),
        React.createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          React.createElement(
            Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreSectionsEdit;
}(PureComponent);

var FormCoreSectionsEdit = Form.create()(InnerFormCoreSectionsEdit);
export default FormCoreSectionsEdit;