'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _FieldType = require('../Constants/FieldType');

var _FieldType2 = _interopRequireDefault(_FieldType);

var _OptionType = require('../Constants/OptionType');

var _OptionType2 = _interopRequireDefault(_OptionType);

var _InputStyle = require('../Constants/InputStyle');

var _InputStyle2 = _interopRequireDefault(_InputStyle);

var _MoneyInput = require('../MoneyInput');

var _MoneyInput2 = _interopRequireDefault(_MoneyInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var FormItem = _antd.Form.Item;
var Option = _antd.Select.Option;

var RadioButton = _antd.Radio.Button;
var RadioGroup = _antd.Radio.Group;
var InputGroup = _antd.Input.Group;
var DefaultFieldType = _FieldType2['default'].Custom;
var DefaultOptionType = _OptionType2['default'].Custom;

var InnerFormCoreFieldsNew = function (_PureComponent) {
  (0, _inherits3['default'])(InnerFormCoreFieldsNew, _PureComponent);

  function InnerFormCoreFieldsNew() {
    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, InnerFormCoreFieldsNew);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      form: {},
      parent: null,
      parents: [],
      inputSelectOptions: [],
      inputStyle: null,
      fieldType: DefaultFieldType,
      selectOptions: [],
      selectOptionEditing: false,
      selectOptionVisible: false,
      selectOptionRecord: null
    }, _this.fetch = function (props) {
      _this.setState({
        loading: true
      });
      props.fetch(function (data0) {
        _this.setState({
          form: data0
        });
        if (data0.Parents.length > 0) {
          data0.Parents.forEach(function (form0) {
            props.fetchSpecific(form0.Id, function (data) {
              var section = data0.Sections.find(function (x) {
                return '' + x.Id === props.sectionId;
              });
              var formParent = data;
              var parents = [];
              if (section.ParentId > 0) {
                parents = _lodash2['default'].filter(formParent.Fields, function (y) {
                  return section.ParentId === y.SectionId;
                });
              }
              _this.setState(function (prevState) {
                var oldParents = prevState.parents || [];
                return {
                  loading: false,
                  parents: oldParents.concat(parents)
                };
              });
            });
          });
        } else {
          _this.setState({
            loading: false
          });
        }
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      var selectOptions = _this.state.selectOptions;

      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          var data = (0, _extends3['default'])({}, values);
          delete data.ModalOptionType;
          delete data.ModalValue;
          delete data.ModalDisplay;
          if (data.Column && Array.isArray(data.Column) && data.Column.length === 1) {
            var _data$Column = data.Column;
            data.Column = _data$Column[0];
          }
          if (_InputStyle2['default'].RangePicker === data.InputStyle) {
            data.DefaultValue = [data.DefaultValue0, data.DefaultValue1];
            data.PlaceHolder = [data.PlaceHolder0, data.PlaceHolder1];
            delete data.DefaultValue0;
            delete data.DefaultValue1;
            delete data.PlaceHolder0;
            delete data.PlaceHolder1;
          }
          if (_InputStyle2['default'].InputNumber === data.InputStyle) {
            data.Payload = {
              Prefix: data.Prefix,
              Suffix: data.Suffix
            };
            delete data.Prefix;
            delete data.Suffix;
          }
          if (_InputStyle2['default'].Select === data.InputStyle) {
            data.Payload = {
              Mode: data.Mode,
              TokenSeparators: [','],
              Options: selectOptions
            };
          }
          if (_this.props.handleSubmit) {
            _this.props.handleSubmit(data, selectOptions);
          }
          _this.props.submit(data);
        }
      });
    }, _this.handleOptionOk = function () {
      _this.setState(function (prevState) {
        var selectOptionEditing = prevState.selectOptionEditing,
            selectOptionRecord = prevState.selectOptionRecord,
            selectOptions = prevState.selectOptions;

        var newSelectOptions = _lodash2['default'].clone(selectOptions);
        var recordValue = null;
        if (selectOptionEditing) {
          var record = newSelectOptions.find(function (x) {
            return x.ID === selectOptionRecord.ID;
          });
          record.Display = _this.props.form.getFieldValue('ModalDisplay');
          record.OptionType = _this.props.form.getFieldValue('ModalOptionType');
          if (_OptionType2['default'].Custom === record.OptionType) {
            record.Value = record.Display;
            recordValue = record.Display;
          } else {
            record.Value = _this.props.form.getFieldValue('ModalValue');
            recordValue = _this.props.form.getFieldValue('ModalValue');
          }
        } else {
          var maxID = _lodash2['default'].max(_lodash2['default'].map(selectOptions, function (o) {
            return o.ID;
          })) || 0;
          var h = {
            ID: maxID + 1,
            Value: _this.props.form.getFieldValue(_OptionType2['default'].Custom === _this.props.form.getFieldValue('ModalOptionType') ? 'ModalDisplay' : 'ModalValue'),
            Display: _this.props.form.getFieldValue('ModalDisplay'),
            FieldType: _this.props.form.getFieldValue('ModalOptionType')
          };
          recordValue = h.Value;
          newSelectOptions.push(h);
        }
        _this.props.form.setFieldsValue({
          ModalOptionType: DefaultOptionType,
          ModalValue: null,
          ModalDisplay: null
        });

        if (_this.props.handleOptionOk) {
          _this.props.handleOptionOk({}, recordValue, _this.props.form.getFieldValue);
        }

        return {
          selectOptions: newSelectOptions,
          selectOptionRecord: {},
          selectOptionEditing: false,
          selectOptionVisible: false
        };
      });
    }, _this.handleOptionCancel = function () {
      _this.setState({
        selectOptionRecord: {},
        selectOptionEditing: false,
        selectOptionVisible: false
      });
      _this.props.form.setFieldsValue({
        ModalOptionType: DefaultOptionType,
        ModalValue: null,
        ModalDisplay: null
      });
    }, _this.handleDeleteOption = function (option) {
      var ID = option.ID;

      _this.setState(function (prevState) {
        var selectOptions = prevState.selectOptions;

        var newSelectOptions = _lodash2['default'].clone(selectOptions);
        _lodash2['default'].remove(newSelectOptions, function (o) {
          return o.ID === ID;
        });
        return {
          selectOptions: newSelectOptions
        };
      });
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  InnerFormCoreFieldsNew.prototype.componentDidMount = function componentDidMount() {
    this.fetch(this.props);
  };

  InnerFormCoreFieldsNew.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch(nextProps);
    }
  };

  InnerFormCoreFieldsNew.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        form = _state.form,
        parent = _state.parent,
        parents = _state.parents,
        inputSelectOptions = _state.inputSelectOptions;
    var _state2 = this.state,
        inputStyle = _state2.inputStyle,
        fieldType = _state2.fieldType;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var formItemLayoutModal = {
      labelCol: {
        xs: { span: 6 }
      },
      wrapperCol: {
        xs: { span: 18 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    var inputDefaultValue = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Default Value',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(_react2['default'].createElement(_antd.Input, { placeholder: 'Default value of the field' }))
    );

    var inputPlaceholder = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Placeholder',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('PlaceHolder', {
        initialValue: parent ? parent.PlaceHolder : null
      })(_react2['default'].createElement(_antd.Input, { placeholder: 'Text displayed when the field is blank' }))
    );

    var rangeDefaultValue = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Default Value',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        ),
        style: { margin: 0 }
      }),
      _react2['default'].createElement(
        InputGroup,
        { compact: true },
        _react2['default'].createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('DefaultValue0', {
            initialValue: parent ? parent.DefaultValue && Array.isArray(parent.DefaultValue) && parent.DefaultValue[0] ? (0, _moment2['default'])(parent.DefaultValue[0]) : null : null
          })(_react2['default'].createElement(_antd.DatePicker, { className: 'formcore_range', placeholder: 'Left' }))
        ),
        _react2['default'].createElement(_antd.Input, {
          style: {
            width: 30,
            pointerEvents: 'none',
            backgroundColor: '#fff',
            position: 'relative',
            top: 4,
            border: 0
          },
          placeholder: '~',
          disabled: true
        }),
        _react2['default'].createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('DefaultValue1', {
            initialValue: parent ? parent.DefaultValue && Array.isArray(parent.DefaultValue) && parent.DefaultValue[1] ? (0, _moment2['default'])(parent.DefaultValue[1]) : null : null
          })(_react2['default'].createElement(_antd.DatePicker, { className: 'formcore_range', placeholder: 'Right' }))
        )
      )
    );

    var rangePlaceholder = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Placeholder',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        ),
        style: { margin: 0 }
      }),
      _react2['default'].createElement(
        InputGroup,
        { compact: true },
        _react2['default'].createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('PlaceHolder0', {
            initialValue: parent ? parent.PlaceHolder && Array.isArray(parent.PlaceHolder) && parent.PlaceHolder[0] ? parent.PlaceHolder[0] : null : null
          })(_react2['default'].createElement(_antd.Input, { className: 'formcore_range', placeholder: 'Left' }))
        ),
        _react2['default'].createElement(_antd.Input, {
          style: {
            width: 30,
            pointerEvents: 'none',
            backgroundColor: '#fff',
            position: 'relative',
            top: 4,
            border: 0
          },
          placeholder: '~',
          disabled: true
        }),
        _react2['default'].createElement(
          FormItem,
          { style: { width: 'calc(50% - 15px)' } },
          getFieldDecorator('PlaceHolder1', {
            initialValue: parent ? parent.PlaceHolder && Array.isArray(parent.PlaceHolder) && parent.PlaceHolder[1] ? parent.PlaceHolder[1] : null : null
          })(_react2['default'].createElement(_antd.Input, { className: 'formcore_range', placeholder: 'Right' }))
        )
      )
    );

    var moneyDefaultValue = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Default Value',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(_react2['default'].createElement(_MoneyInput2['default'], null))
    );

    var selectDefaultValue = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Default Value',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(_react2['default'].createElement(
        _antd.Select,
        {
          mode: parent ? parent.Mode : null,
          tokenSeparators: parent ? parent.TokenSeparators : null
        },
        _lodash2['default'].map(this.state.selectOptions || (parent ? parent.Options : []), function (option) {
          return _react2['default'].createElement(
            Option,
            { key: option.Value, value: option.Value },
            option.Display
          );
        })
      ))
    );

    var numberDefaultValue = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Default Value',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('DefaultValue', {
        initialValue: parent ? parent.DefaultValue : null
      })(_react2['default'].createElement(_antd.InputNumber, null))
    );

    var inputNumberPrefix = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Prefix',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('Prefix', {
        initialValue: parent ? parent.Prefix : null
      })(_react2['default'].createElement(_antd.Input, { placeholder: 'Text displayed before the number' }))
    );

    var inputSelectMode = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, { label: 'Mode' }),
      getFieldDecorator('Mode', {
        initialValue: parent ? parent.Mode : null
      })(_react2['default'].createElement(
        _antd.Select,
        {
          placeholder: 'Pick a select input box style',
          onChange: function onChange(x) {
            if (parent) {
              parent.Mode = x;
            }
          }
        },
        _react2['default'].createElement(
          Option,
          { value: '' },
          'Dropdown'
        ),
        _react2['default'].createElement(
          Option,
          { value: 'tags' },
          'Tags'
        ),
        _react2['default'].createElement(
          Option,
          { value: 'multiple' },
          'Multiple'
        ),
        _react2['default'].createElement(
          Option,
          { value: 'combobox' },
          'Combo-box'
        )
      ))
    );
    var inputSelectValues = _react2['default'].createElement(
      _react.Fragment,
      null,
      _react2['default'].createElement(
        FormItem,
        (0, _extends3['default'])({}, formItemLayout, { label: 'Options' }),
        _react2['default'].createElement(_antd.Table, {
          scrollWidth: 350,
          style: { maxHeight: 300, overflowY: 'auto' },
          size: 'small',
          rowKey: 'ID',
          columns: [{
            title: 'Option',
            dataIndex: 'Display',
            key: 'Display',
            width: 'calc(100% - 80px)',
            render: function render(text) {
              return text;
            }
          }, {
            title: _react2['default'].createElement(_antd.Button, {
              type: 'primary',
              icon: 'plus',
              style: { float: 'right' },
              onClick: function onClick() {
                _this2.setState({
                  selectOptionRecord: {
                    OptionType: DefaultOptionType
                  },
                  selectOptionEditing: false,
                  selectOptionVisible: true
                });
              }
            }),
            dataIndex: '',
            key: 'ID',
            width: 80,
            render: function render(text, record) {
              return _react2['default'].createElement(_antd.Button, {
                icon: 'edit',
                onClick: function onClick() {
                  _this2.props.form.setFieldsValue({
                    ModalOptionType: record.OptionType,
                    ModalValue: record.Value,
                    ModalDisplay: record.Display
                  });
                  _this2.setState({
                    selectOptionRecord: record,
                    selectOptionEditing: true,
                    selectOptionVisible: true
                  });
                }
              });
            }
          }],
          dataSource: this.state.selectOptions,
          pagination: false
        })
      ),
      _react2['default'].createElement(
        _antd.Modal,
        {
          title: this.state.selectOptionEditing ? 'Edit: ' + this.state.selectOptionRecord.Display : 'New Option',
          visible: this.state.selectOptionVisible,
          onOk: this.handleOptionOk,
          onCancel: this.handleOptionCancel
        },
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayoutModal, { label: 'Option Type' }),
          getFieldDecorator('ModalOptionType', {
            initialValue: this.state.selectOptionEditing ? this.state.selectOptionRecord.OptionType : DefaultOptionType
          })(_react2['default'].createElement(
            RadioGroup,
            {
              onChange: function onChange(e) {
                if (_this2.state.selectOptionRecord) {
                  _this2.setState(function (st) {
                    return {
                      selectOptionRecord: (0, _extends3['default'])({}, st.selectOptionRecord, {
                        OptionType: e.target.value
                      })
                    };
                  });
                } else {
                  _this2.setState({
                    selectOptionRecord: {
                      OptionType: e.target.value
                    }
                  });
                }
                return true;
              }
            },
            _react2['default'].createElement(
              _react.Fragment,
              null,
              _react2['default'].createElement(
                RadioButton,
                { value: _OptionType2['default'].BuiltIn },
                'Built-in'
              ),
              _react2['default'].createElement(
                RadioButton,
                { value: _OptionType2['default'].Custom },
                'Custom'
              )
            )
          ))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayoutModal, {
            label: 'Built-in Option',
            style: {
              display: this.state.selectOptionRecord && _OptionType2['default'].BuiltIn === this.state.selectOptionRecord.OptionType ? 'block' : 'none'
            }
          }),
          getFieldDecorator('ModalValue', {
            initialValue: this.state.selectOptionRecord ? this.state.selectOptionRecord.Value : null
          })(_react2['default'].createElement(
            _antd.Select,
            {
              style: { width: '100%' },
              placeholder: 'Select a built-in option',
              onChange: function onChange(x) {
                _this2.props.form.setFieldsValue({
                  ModalDisplay: inputSelectOptions[x]
                });
                if (_this2.state.selectOptionRecord) {
                  _this2.setState(function (st) {
                    return {
                      selectOptionRecord: (0, _extends3['default'])({}, st.selectOptionRecord, {
                        Value: x,
                        Display: inputSelectOptions[x]
                      })
                    };
                  });
                } else {
                  _this2.setState({
                    selectOptionRecord: {
                      Value: x,
                      Display: inputSelectOptions[x]
                    }
                  });
                }
              }
            },
            _lodash2['default'].map(_lodash2['default'].keys(inputSelectOptions), function (key) {
              return _react2['default'].createElement(
                Option,
                { key: key, value: key },
                inputSelectOptions[key]
              );
            })
          ))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayoutModal, { label: 'Displayed As' }),
          getFieldDecorator('ModalDisplay', {
            initialValue: this.state.selectOptionRecord ? this.state.selectOptionRecord.Display : null
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'How should this option be displayed' }))
        )
      )
    );

    var inputNumberSuffix = _react2['default'].createElement(
      FormItem,
      (0, _extends3['default'])({}, formItemLayout, {
        label: _react2['default'].createElement(
          'span',
          null,
          'Suffix',
          _react2['default'].createElement(
            'em',
            { className: 'formcore_optional' },
            ' (Optional)'
          )
        )
      }),
      getFieldDecorator('Suffix', {
        initialValue: parent ? parent.Suffix : null
      })(_react2['default'].createElement(_antd.Input, { placeholder: 'Text displayed after the number' }))
    );

    return _react2['default'].createElement(
      _antd.Card,
      { bordered: false, loading: loading, title: 'New Field' },
      _react2['default'].createElement(
        _antd.Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        form && form.Parents && form.Parents.length > 0 && parents && parents.length > 0 ? _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            help: _react2['default'].createElement(
              'span',
              null,
              this.props.providedBy(form)
            ),
            label: _react2['default'].createElement(
              'span',
              null,
              'Copy and Modify',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              ),
              '\xA0',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                _react2['default'].createElement(
                  _antd.Tooltip,
                  { title: 'Select a field if you intend to copy and modify an existing field; otherwise leave it blank.' },
                  _react2['default'].createElement(_antd.Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId')(_react2['default'].createElement(
            _antd.Select,
            {
              allowClear: true,
              showSearch: true,
              placeholder: 'Select an existing field or leave it blank',
              onChange: function onChange(parentId) {
                var parentNew = null;
                _this2.setState(function (prevState) {
                  var inputStyleNew = prevState.inputStyleNew,
                      fieldTypeNew = prevState.fieldTypeNew;

                  if (parentId && parentId > 0) {
                    parentNew = parents.find(function (x) {
                      return x.Id === parentId;
                    });
                    if (parentNew) {
                      inputStyleNew = parentNew.InputStyle;
                      fieldTypeNew = parentNew.FieldType;
                    }
                  }
                  if (parentNew && parentNew.Payload) {
                    parentNew = (0, _extends3['default'])({}, parentNew, parentNew.Payload);
                  }
                  var h = {
                    parent: parentNew,
                    inputStyle: inputStyleNew,
                    fieldType: fieldTypeNew
                  };
                  if (parentNew && parentNew.Options && _lodash2['default'].isArray(parentNew.Options)) {
                    h.inputSelectOptions = _this2.props.availableOptions(parentNew.Column);
                    h.selectOptions = _lodash2['default'].map(parentNew.Options, function (option, i) {
                      return (0, _extends3['default'])({ ID: i }, option);
                    });
                  } else {
                    h.selectOptions = [];
                  }
                  return h;
                });
              }
            },
            parents.map(function (y) {
              return _react2['default'].createElement(
                _antd.Select.Option,
                { key: y.Id, value: y.Id },
                y.Label
              );
            })
          ))
        ) : null,
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, { label: _react2['default'].createElement(
              'span',
              null,
              'Type'
            ) }),
          getFieldDecorator('FieldType', {
            initialValue: fieldType
          })(_react2['default'].createElement(
            RadioGroup,
            {
              onChange: function onChange(e) {
                _this2.setState({
                  fieldType: e.target.value
                });
                return true;
              }
            },
            _react2['default'].createElement(
              RadioButton,
              { value: _FieldType2['default'].BuiltIn },
              'Built-in'
            ),
            _react2['default'].createElement(
              RadioButton,
              { value: _FieldType2['default'].Custom },
              'Custom'
            )
          ))
        ),
        _FieldType2['default'].BuiltIn !== fieldType ? null : _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, { label: 'Built-in Columns' }),
          getFieldDecorator('Column', {
            rules: [{
              required: true,
              message: 'Built-in fields require at least one column'
            }],
            initialValue: parent && parent.Column ? ('' + parent.Column).split('__FORMCORE__') : []
          })(_react2['default'].createElement(
            _antd.Select,
            {
              mode: 'tags',
              style: { width: '100%' },
              placeholder: 'Select built-in columns for this field',
              onChange: function onChange(handlers) {
                var availableOptions = _this2.props.availableOptions(handlers);
                var calcSelectOptions = [];
                var i = 0;
                _lodash2['default'].each(availableOptions, function (val, key) {
                  i += 1;
                  calcSelectOptions.push({
                    ID: i,
                    Value: key,
                    Display: val,
                    OptionType: _OptionType2['default'].BuiltIn
                  });
                });
                var h = {
                  inputSelectOptions: availableOptions,
                  selectOptions: calcSelectOptions
                };
                handlers.forEach(function (handler) {
                  var info = _this2.props.availableHandlers.find(function (x) {
                    return x[0] === handler;
                  });
                  if (info) {
                    h = (0, _extends3['default'])({}, h, info[3]);
                  }
                });
                _this2.setState(h);
              }
            },
            this.props.availableHandlers.map(function (x) {
              return _react2['default'].createElement(
                Option,
                { value: x[0], key: x[0] },
                _react2['default'].createElement(
                  _antd.Tooltip,
                  { placement: 'bottom', title: x[2] },
                  x[1]
                )
              );
            })
          ))
        ),
        _FieldType2['default'].BuiltIn !== fieldType ? null : _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, { label: 'Built-in Handlers' }),
          getFieldDecorator('Handlers', {
            initialValue: (parent || {}).Handlers || []
          })(_react2['default'].createElement(
            _antd.Select,
            {
              mode: 'tags',
              style: { width: '100%' },
              placeholder: 'Select built-in handlers for this field'
            },
            this.props.availableHandlers.map(function (x) {
              return _react2['default'].createElement(
                Option,
                { value: x[0], key: x[0] },
                _react2['default'].createElement(
                  _antd.Tooltip,
                  { placement: 'bottom', title: x[2] },
                  x[1]
                )
              );
            })
          ))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            label: _react2['default'].createElement(
              'span',
              null,
              'Label',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Label', {
            initialValue: parent ? parent.Label : null
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'Label of the field' }))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            label: 'Position',
            help: 'The higher the number is, the lower on the page will the field be displayed.'
          }),
          getFieldDecorator('Position', {
            rules: [{
              required: true,
              message: 'Please enter the position of the field'
            }],
            initialValue: parent ? parent.Position : 0
          })(_react2['default'].createElement(_antd.InputNumber, { style: { width: '100%' } }))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, { label: 'Input Style' }),
          getFieldDecorator('InputStyle', {
            initialValue: inputStyle
          })(_react2['default'].createElement(
            _antd.Select,
            {
              placeholder: 'Select the style of the field\'s input box',
              onChange: function onChange(x) {
                _this2.setState(function (pervState) {
                  var h = {
                    inputStyle: x
                  };
                  if (_this2.props.onInputStyleChange) {
                    _this2.props.onInputStyleChange(x, pervState, h);
                  }
                  return h;
                });
              }
            },
            _lodash2['default'].map(_lodash2['default'].keys(this.props.availableInputStyle), function (key) {
              return _react2['default'].createElement(
                Option,
                {
                  key: _this2.props.availableInputStyle[key],
                  value: _this2.props.availableInputStyle[key]
                },
                key
              );
            })
          ))
        ),
        _InputStyle2['default'].Hidden !== inputStyle ? null : inputDefaultValue,
        _InputStyle2['default'].Input !== inputStyle ? null : inputDefaultValue,
        _InputStyle2['default'].Input !== inputStyle ? null : inputPlaceholder,
        _InputStyle2['default'].RangePicker !== inputStyle ? null : rangeDefaultValue,
        _InputStyle2['default'].RangePicker !== inputStyle ? null : rangePlaceholder,
        _InputStyle2['default'].MoneyInput !== inputStyle ? null : moneyDefaultValue,
        _InputStyle2['default'].MoneyInput !== inputStyle ? null : inputPlaceholder,
        _InputStyle2['default'].InputNumber !== inputStyle ? null : numberDefaultValue,
        _InputStyle2['default'].InputNumber !== inputStyle ? null : inputPlaceholder,
        _InputStyle2['default'].InputNumber !== inputStyle ? null : inputNumberPrefix,
        _InputStyle2['default'].InputNumber !== inputStyle ? null : inputNumberSuffix,
        _InputStyle2['default'].Select !== inputStyle ? null : inputSelectMode,
        _InputStyle2['default'].Select !== inputStyle ? null : inputSelectValues,
        _InputStyle2['default'].Select !== inputStyle ? null : selectDefaultValue,
        this.props.fieldRender && this.props.fieldRender({}, inputStyle, this.props.form.setFieldsValue, getFieldDecorator, formItemLayoutModal, formItemLayout, this.handleOptionOk, this.handleOptionCancel, this.state, this.setState),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, submitFormLayout, { style: { marginTop: 32 } }),
          _react2['default'].createElement(
            _antd.Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFieldsNew;
}(_react.PureComponent);

var FormCoreFieldsNew = _antd.Form.create()(InnerFormCoreFieldsNew);
exports['default'] = FormCoreFieldsNew;
module.exports = exports['default'];