'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _RenderField = require('./RenderField');

var _RenderField2 = _interopRequireDefault(_RenderField);

var _InputStyle = require('./Constants/InputStyle');

var _InputStyle2 = _interopRequireDefault(_InputStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var FormCoreForm = function (_React$Component) {
  (0, _inherits3['default'])(FormCoreForm, _React$Component);

  function FormCoreForm() {
    (0, _classCallCheck3['default'])(this, FormCoreForm);
    return (0, _possibleConstructorReturn3['default'])(this, _React$Component.apply(this, arguments));
  }

  FormCoreForm.prototype.render = function render() {
    var _props = this.props,
        form = _props.form,
        data = _props.data,
        sections = _props.sections,
        fields = _props.fields,
        renderExtra = _props.renderExtra,
        style = _props.style;

    var defaultValues = {};
    _lodash2['default'].each(fields, function (x) {
      defaultValues[x.Column] = x.DefaultValue;
    });
    return sections.map(function (x) {
      var localFields = _lodash2['default'].filter(fields, function (y) {
        return x.Id === y.SectionId;
      });
      if (x.ParentId > 0) {
        _lodash2['default'].forEach(_lodash2['default'].filter(fields, function (y) {
          return x.ParentId === y.SectionId;
        }), function (y) {
          if (undefined === _lodash2['default'].find(localFields, function (z) {
            return z.ParentId === y.Id;
          })) {
            localFields.push(y);
          }
        });
      }
      var visibleFields = _lodash2['default'].filter(localFields, function (f) {
        return f.InputStyle !== _InputStyle2['default'].Hidden;
      });
      localFields.sort(function (a, b) {
        return a.Position - b.Position;
      });
      var rowColContent = null;
      if (localFields.length === 1) {
        rowColContent = (0, _RenderField2['default'])(localFields[0], form, data, {}, renderExtra);
      } else {
        rowColContent = _react2['default'].createElement(
          _antd.Row,
          { gutter: 16 },
          localFields.map(function (y) {
            return _react2['default'].createElement(
              _antd.Col,
              { lg: 8, md: 12, sm: 24, key: y.Id, hidden: _InputStyle2['default'].Hidden === y.InputStyle },
              (0, _RenderField2['default'])(y, form, data, {}, renderExtra)
            );
          })
        );
      }
      return _react2['default'].createElement(
        _antd.Card,
        {
          key: x.Id,
          title: x.Title,
          className: 'formcore_btm24',
          bordered: false,
          style: style,
          hidden: !(visibleFields && visibleFields.length > 0)
        },
        rowColContent
      );
    });
  };

  return FormCoreForm;
}(_react2['default'].Component);

exports['default'] = FormCoreForm;
module.exports = exports['default'];