'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var FormItem = _antd.Form.Item;

var InnerFormCoreFormsEdit = function (_PureComponent) {
  (0, _inherits3['default'])(InnerFormCoreFormsEdit, _PureComponent);

  function InnerFormCoreFormsEdit() {
    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, InnerFormCoreFormsEdit);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      entity: {}
    }, _this.fetch = function () {
      _this.setState({ loading: true });

      _this.props.fetch(function (entity) {
        var newEntity = (0, _extends3['default'])({ ParentId: entity.ParentIds[0] }, entity);
        _this.setState({ loading: false, entity: newEntity });
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.clearAjaxError(values);
          var newValues = (0, _extends3['default'])({ ParentIds: [values.ParentId] }, values);
          _this.props.submit(newValues);
        }
      });
    }, _this.clearAjaxError = function (origValues) {
      var fields = {
        Title: { value: origValues.Name, errors: null }
      };
      fields.ParentId = { value: origValues.Name, errors: null };
      _this.props.form.setFields(fields);
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  InnerFormCoreFormsEdit.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  InnerFormCoreFormsEdit.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  InnerFormCoreFormsEdit.prototype.render = function render() {
    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        entity = _state.entity;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    return _react2['default'].createElement(
      _antd.Card,
      { bordered: false, loading: loading, title: entity.Title ? entity.Title : null },
      _react2['default'].createElement(
        _antd.Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            label: _react2['default'].createElement(
              'span',
              null,
              'Title',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            rules: [{ required: true, message: 'Please enter the title of the new product offer' }],
            initialValue: entity.Title
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'Title of the new product offer' }))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, submitFormLayout, { style: { marginTop: 32 } }),
          _react2['default'].createElement(
            _antd.Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFormsEdit;
}(_react.PureComponent);

var FormCoreFormsEdit = _antd.Form.create()(InnerFormCoreFormsEdit);
exports['default'] = FormCoreFormsEdit;
module.exports = exports['default'];