'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var FormItem = _antd.Form.Item;
var Option = _antd.Select.Option;

var InnerFormCoreFormsNew = function (_PureComponent) {
  (0, _inherits3['default'])(InnerFormCoreFormsNew, _PureComponent);

  function InnerFormCoreFormsNew() {
    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, InnerFormCoreFormsNew);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      parents: [],
      parentId: null
    }, _this.fetch = function () {
      _this.setState({
        loading: true
      });
      _this.props.fetchParents(function (data) {
        _this.setState({
          loading: false,
          parents: data
        });
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.clearAjaxError(values);
          var h = (0, _extends3['default'])({}, values);
          if (h.ParentId) {
            h.ParentIds = [h.ParentId];
          } else {
            h.ParentIds = [];
          }
          delete h.ProductId;
          _this.props.submit(h);
        }
      });
    }, _this.clearAjaxError = function (origValues) {
      var fields = {
        Title: { value: origValues.Name, errors: null }
      };
      fields.ParentId = { value: origValues.ParentId, errors: null };
      _this.props.form.setFields(fields);
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  InnerFormCoreFormsNew.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  InnerFormCoreFormsNew.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  InnerFormCoreFormsNew.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        parents = _state.parents,
        parentId = _state.parentId;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    var parent = null;
    if (parentId && parentId > 0) {
      parent = parents.find(function (x) {
        return x.Id === parentId;
      });
    }

    return _react2['default'].createElement(
      _antd.Card,
      { bordered: false, loading: loading, title: 'New Product Offer' },
      _react2['default'].createElement(
        _antd.Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            help: this.props.parentsHelp,
            label: _react2['default'].createElement(
              'span',
              null,
              'Based on\xA0',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                _react2['default'].createElement(
                  _antd.Tooltip,
                  { title: 'The existing components and sections of the base will be referenced and never need to be created again.' },
                  _react2['default'].createElement(_antd.Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId', {
            rules: [{ required: true, message: 'Please select an existing product offer' }]
          })(_react2['default'].createElement(
            _antd.Select,
            {
              showSearch: true,
              onChange: function onChange(x) {
                return _this2.setState({ parentId: x });
              },
              placeholder: 'Select an existing product offer'
            },
            parents.map(function (x) {
              return _react2['default'].createElement(
                Option,
                { key: x.Id, value: x.Id },
                x.Title
              );
            })
          ))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, formItemLayout, {
            label: _react2['default'].createElement(
              'span',
              null,
              'Title',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            initialValue: parent ? parent.Title : null
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'Title of the new product offer' }))
        ),
        _react2['default'].createElement(
          FormItem,
          (0, _extends3['default'])({}, submitFormLayout, { style: { marginTop: 32 } }),
          _react2['default'].createElement(
            _antd.Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFormsNew;
}(_react.PureComponent);

var FormCoreFormsNew = _antd.Form.create()(InnerFormCoreFormsNew);
exports['default'] = FormCoreFormsNew;
module.exports = exports['default'];