'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _DescriptionList = require('ant-design-pro/lib/DescriptionList');

var _DescriptionList2 = _interopRequireDefault(_DescriptionList);

var _RenderField = require('../RenderField');

var _RenderField2 = _interopRequireDefault(_RenderField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var InnerFormCoreFormsShow = function (_Component) {
  (0, _inherits3['default'])(InnerFormCoreFormsShow, _Component);

  function InnerFormCoreFormsShow() {
    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, InnerFormCoreFormsShow);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: true,
      form: {}
    }, _this.fetch = function (props) {
      _this.setState({
        loading: true
      });
      props.fetch(function (data) {
        _this.setState({
          loading: false,
          form: data
        });
      });
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  InnerFormCoreFormsShow.prototype.componentDidMount = function componentDidMount() {
    this.fetch(this.props);
  };

  InnerFormCoreFormsShow.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch(nextProps);
    }
  };

  InnerFormCoreFormsShow.prototype.render = function render() {
    var _this2 = this;

    var _state = this.state,
        loading = _state.loading,
        form = _state.form;

    var sectionsColumns = [{
      title: 'Name',
      dataIndex: 'Id',
      key: 'Id',
      render: function render(text, row) {
        if (row.SectionOperation) {
          return _this2.props.newSectionLink(row.Id);
        }
        if (row.FieldOperation) {
          return _this2.props.newFieldLink(row.Id, row.SectionId);
        }
        if (row.Title) {
          return _this2.props.sectionLink(row.Id, row.Id, row.Title);
        }
        return _this2.props.fieldLink(row.Id, row.SectionId, row.Id.split('_')[1], row.Label);
      }
    }, {
      title: 'Preview',
      render: function render(text, row) {
        if (row.Label) {
          var y = (0, _extends3['default'])({}, row);
          y.Label = null;
          return (0, _RenderField2['default'])(y, _this2.props.form, {
            style: { width: '100%', display: 'inline-block' }
          }, _this2.props.renderExtra);
        }
        return null;
      }
    }];
    var sections = !form ? [] : _lodash2['default'].filter(form.Sections, function (x) {
      return form.Id === x.FormId;
    }).map(function (x) {
      return (0, _extends3['default'])({}, x, {
        children: _lodash2['default'].filter(form.Fields, function (y) {
          return x.Id === y.SectionId && form.Id === x.FormId;
        }).map(function (y) {
          return (0, _extends3['default'])({}, y, {
            Id: x.Id + '_' + y.Id
          });
        }).concat([{ Id: x.Id + '_FieldOperation', FieldOperation: true, SectionId: x.Id }])
      });
    }).concat([{ Id: 'SectionOperation', SectionOperation: true }]);
    return _react2['default'].createElement(
      _antd.Card,
      {
        className: 'formcore-card-button-fix',
        title: form.Title ? form.Title : 'Product Offer',
        loading: loading,
        style: { marginBottom: 24 },
        extra: this.props.editFormButton
      },
      form ? _react2['default'].createElement(
        _react.Fragment,
        null,
        _react2['default'].createElement(
          _DescriptionList2['default'],
          { size: 'large', title: 'Introduction', style: { marginBottom: 32 } },
          this.props.formIntroduction(form)
        ),
        _react2['default'].createElement(_antd.Divider, { style: { marginBottom: 32 } }),
        _react2['default'].createElement(
          'div',
          { className: 'formcore_title' },
          form.Parents && form.Parents.length > 0 ? 'Modifications' : 'Components'
        ),
        _react2['default'].createElement(_antd.Table, {
          fixLeft: false,
          scrollWidth: 350,
          className: 'formcore_formTable',
          style: { marginBottom: 24 },
          pagination: false,
          loading: loading,
          dataSource: sections,
          columns: sectionsColumns,
          rowKey: 'Id',
          expandedRowKeys: sections.map(function (x) {
            return x.Id;
          })
        })
      ) : null
    );
  };

  return InnerFormCoreFormsShow;
}(_react.Component);

var FormCoreFormsShow = _antd.Form.create()(InnerFormCoreFormsShow);
exports['default'] = FormCoreFormsShow;
module.exports = exports['default'];