'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _numeral = require('numeral');

var _numeral2 = _interopRequireDefault(_numeral);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var MoneyInput = function (_React$Component) {
  (0, _inherits3['default'])(MoneyInput, _React$Component);

  function MoneyInput() {
    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, MoneyInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onChange = function (e) {
      var value = e.target.value;

      var reg = /^-?(0|[1-9][0-9]*)(\.[0-9]*)?$/;
      if (!Number.isNaN(value) && reg.test(value) || value === '' || value === '-') {
        _this.props.onChange(value);
      }
    }, _this.onBlur = function () {
      var _this$props = _this.props,
          value = _this$props.value,
          onBlur = _this$props.onBlur,
          onChange = _this$props.onChange;

      if (value && (value.charAt(value.length - 1) === '.' || value === '-')) {
        onChange({ value: value.slice(0, -1) });
      }
      if (onBlur) {
        onBlur();
      }
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  // '.' at the end or only '-' in the input box.


  MoneyInput.prototype.render = function render() {
    var _props = this.props,
        value = _props.value,
        _props$addonBefore = _props.addonBefore,
        addonBefore = _props$addonBefore === undefined ? '$' : _props$addonBefore,
        addonAfter = _props.addonAfter,
        _props$placeholder = _props.placeholder,
        placeholder = _props$placeholder === undefined ? '0.00' : _props$placeholder,
        _props$formatTooltip = _props.formatTooltip,
        formatTooltip = _props$formatTooltip === undefined ? true : _props$formatTooltip,
        restProps = (0, _objectWithoutProperties3['default'])(_props, ['value', 'addonBefore', 'addonAfter', 'placeholder', 'formatTooltip']);

    var title = 'Input an amount';
    if (value) {
      title = value;
      if (formatTooltip) title = _react2['default'].createElement(
        'span',
        { className: 'formcore-numeric-input-title' },
        value !== '-' ? '$' + (0, _numeral2['default'])(value).format('0,0.00') : '-'
      );
    }

    return _react2['default'].createElement(
      'div',
      { className: 'formcore_moneyinput' },
      _react2['default'].createElement(
        _antd.Tooltip,
        {
          trigger: ['focus'],
          title: title,
          placement: 'bottomLeft',
          overlayClassName: 'formcore-numeric-input'
        },
        _react2['default'].createElement(_antd.Input, (0, _extends3['default'])({}, restProps, {
          value: value,
          onChange: this.onChange,
          onBlur: this.onBlur,
          addonBefore: addonBefore,
          addonAfter: addonAfter,
          placeholder: placeholder,
          maxLength: '25',
          autoComplete: 'off'
        }))
      )
    );
  };

  return MoneyInput;
}(_react2['default'].Component);

exports['default'] = MoneyInput;
module.exports = exports['default'];